package com.example.haiwei_mom;

import androidx.databinding.DataBindingUtil;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyApplication;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.LoginTenantVo;
import com.example.haiwei_mom.data.LoginVm;
import com.example.haiwei_mom.databinding.ActivityMainBinding;
import com.example.haiwei_mom.uitls.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import okhttp3.RequestBody;

public class MainActivity extends BaseActivity {
    private LoginVm loginVm;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // ActivityMainBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_main);
        ActivityMainBinding binding = ActivityMainBinding.inflate(getLayoutInflater());

        setContentView(binding.getRoot());

        loginVm = new LoginVm();
        boolean isRemember = SharedPreferencesUtils.getboolean("isRemember", true);
        if (isRemember) {
            loginVm.setUsername(SharedPreferencesUtils.getstring("user", "admin"));
            loginVm.setPassword(SharedPreferencesUtils.getstring("pass", "admin123"));
            loginVm.setRemember(isRemember);
        }
        binding.setUser(loginVm);

    }

    private void getTenantList() {
        OkGo.<MyResult>get(url + "/auth/tenant/list")
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                        LoginTenantVo loginTenantVo = gson.fromJson(body.getDataJson(), LoginTenantVo.class);
                        var voList = loginTenantVo.getVoList();
                        loginVm.setVoList(voList);
                        }
                    }

                });
    }

    @Override
    protected void onResume() {
        super.onResume();
        getTenantList();
    }

    public void login_click(View view) {


        String pass = loginVm.getPassword();
        String name = loginVm.getUsername();
        if (pass == null || name == null || pass.isEmpty() || name.isEmpty()) return;
        OkGo.<MyResult>post(url + "/auth/pdaLogin")
                .upRequestBody(RequestBody.create(JSON, gson.toJson(loginVm)))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            JSONObject jsonObject = JSONObject.parseObject(body.getDataJson());
                            String accessToken = jsonObject.get("access_token").toString();

                            MyApplication.getApplication().setAccessToken("Bearer "+accessToken);
                            boolean remember = loginVm.isRemember();
                            if (remember) {
                                SharedPreferencesUtils.putboolean("isRemember", remember);
                                SharedPreferencesUtils.putstring("user", name);
                                SharedPreferencesUtils.putstring("pass", pass);
                                SharedPreferencesUtils.putstring("nickname", jsonObject.get("nickname").toString());
                            }
                            Intent intent = new Intent(MainActivity.this, HomePageActivity.class);
                            startActivity(intent);
                            finish();
                        }else {
                            Toast.makeText(MainActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();
                        }


                    }
                });
    }
}