package com.example.haiwei_mom.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.data.WmsBaseLocationVo;
import com.example.haiwei_mom.data.WmsInventoryVo;
import com.example.haiwei_mom.databinding.ItemCheckWorkInventoryBinding;
import com.example.haiwei_mom.databinding.ItemStoreCheckLocationBinding;

import java.util.List;

/**
 * @author wanghao
 * @date 2023/11/17  17:15
 */
public class CheckWorkAdapter extends RecyclerView.Adapter<CheckWorkAdapter.CheckAdapterVH> {
    private Context context;
    private List<WmsInventoryVo> list;
    private LayoutInflater from;


    public CheckWorkAdapter(Context context) {
        this.context = context;
        from = LayoutInflater.from(context);
    }

    public void setList(List<WmsInventoryVo> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public CheckAdapterVH onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemCheckWorkInventoryBinding binding = DataBindingUtil.inflate(from, R.layout.item_check_work_inventory, parent, false);
        return new CheckAdapterVH(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull CheckAdapterVH holder, int position) {
        var item = list.get(position);

        var databing = CheckAdapterVH.binding;
        databing.setVm(item);
        // databing.setVariable(BR.item, item);

        databing.executePendingBindings();
    }

    @Override
    public int getItemCount() {
        return list == null ? 0 : list.size();
    }

    static class CheckAdapterVH extends RecyclerView.ViewHolder {
        private static ItemCheckWorkInventoryBinding binding;
        public CheckAdapterVH(ItemCheckWorkInventoryBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }



}
