package com.example.haiwei_mom.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.data.OutDetail;
import com.example.haiwei_mom.databinding.ItemBindVehicleBinding;
import com.example.haiwei_mom.databinding.ItemRawOutBinding;

import java.util.List;

public class RawOutDetailAdapter extends RecyclerView.Adapter<RawOutDetailAdapter.MyViewHolder> {
    private Context context;
    private LayoutInflater inflater;


    public RawOutDetailAdapter(Context context) {
        this.context = context;
        inflater=LayoutInflater.from(context);
    }

    private List<OutDetail> list;

    public void setList(List<OutDetail> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemRawOutBinding binding=DataBindingUtil.inflate(inflater, R.layout.item_raw_out,parent,false);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        var binding = holder.binding;
        binding.setVm(list.get(position));

    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    public class MyViewHolder extends RecyclerView.ViewHolder{
       private ItemRawOutBinding binding;

        public MyViewHolder(ItemRawOutBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }

    }
}
