package com.example.haiwei_mom.base;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.provider.MediaStore;
import android.util.Log;
import android.view.View;
import android.view.Window;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import androidx.core.content.FileProvider;

import com.example.haiwei_mom.broadcast.MyScannerCall;
import com.example.haiwei_mom.broadcast.MyScannerReceiver;
import com.example.haiwei_mom.uitls.MyToastUitls;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import okhttp3.MediaType;

public class BaseActivity extends AppCompatActivity implements MyScannerCall {

    public static final int CAMERA_PHOTO = 1;
    // public static String url = "http://10.11.184.221:6080";
    // public static String url = "http://192.168.100.100:6080";//设备
    // public static String url = "http://1.13.177.47:6080";
    public static String url = "http://192.168.0.104:6080";
    public ProgressDialog dialog;
    public Gson gson;
    public MediaType JSON = MediaType.parse("application/json; charset=utf-8");
    private MyScannerReceiver myReceiver;
    public Context context;
    public MyToastUitls myToastUitls;
    @SuppressLint("SimpleDateFormat")
    public SimpleDateFormat format= new SimpleDateFormat( "yyyyMMdd_HHmmss");
    // public SimpleDateFormat dateFormat= new SimpleDateFormat( "yyyy-MM-dd");
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.e("TAG", this.getLocalClassName() );
        gson = new GsonBuilder()
                .setLenient()  // 对JSON语法更宽容
                .create();
        this.context=this;
        initDialog();
        initSan();
        myToastUitls=new MyToastUitls(this);
    }

    public static void setUrl(String url) {
        BaseActivity.url = url;
    }

    private void initDialog() {
        dialog = new ProgressDialog(this);
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        dialog.setCanceledOnTouchOutside(false);
        dialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        dialog.setMessage("请求网络中...");
    }

    private void initSan() {
        myReceiver = new MyScannerReceiver(this);
        IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction("com.rfid.SCAN");
        registerReceiver(myReceiver, intentFilter);

    }


    @Override
    protected void onDestroy() {
        super.onDestroy();
        unregisterReceiver(myReceiver);
    }

    public void titleToolClick(View view) {
        finish();
    }



    // 拍照
    private Uri img_uri;
    private File outputImage;
    public void teke_photo() throws IOException {
        outputImage = new File(getExternalCacheDir(), "output_imgage" + format.format(new Date()) + ".jpg");
        outputImage.createNewFile();
        if (Build.VERSION.SDK_INT >= 24) {
            img_uri = FileProvider.getUriForFile(this, "com.example.haiwei_mom", outputImage);
        } else {
            img_uri = Uri.fromFile(outputImage);
        }
        if (PackageManager.PERMISSION_GRANTED == ContextCompat.checkSelfPermission(this, Manifest.permission.CAMERA)) {
            Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");
            intent.putExtra(MediaStore.EXTRA_OUTPUT, img_uri);
            startActivityForResult(intent, CAMERA_PHOTO);
        } else {
            // 提示用户开户权限   拍照和读写sd卡权限
            String[] perms = {Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.CAMERA};
            ActivityCompat.requestPermissions(this, perms, CAMERA_PHOTO);
        }
    }
    // 拍照的回调
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == RESULT_OK) {

            Bitmap compressedImageBitmap = BitmapFactory.decodeFile(outputImage.getPath());
            // 选择压缩质量
            int quality = 10;
            // 创建一个字节数组输出流
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            // 将Bitmap压缩成JPEG格式，并将压缩后的数据保存到字节数组输出流中
            compressedImageBitmap.compress(Bitmap.CompressFormat.JPEG, quality, baos);
            // 将字节数组输出流中的数据转换为字节数组
            byte[] compressedImageData = baos.toByteArray();
            // 清空字节数组输出流
            baos.reset();
            // 将压缩后的字节数组保存到文件中
            FileOutputStream fos = null;
            try {
                fos = new FileOutputStream(outputImage);
                fos.write(compressedImageData);
                fos.flush();
                fos.close();

                tekePhotoResult( img_uri.toString(),outputImage);
            } catch (FileNotFoundException e) {
                throw new RuntimeException(e);
            } catch (IOException e) {
                throw new RuntimeException(e);
            }

        }
    }
    public void tekePhotoResult(String fileUrl,File file){

    }


    @Override
    public void getScannerData(String data) {

    }
}