package com.example.haiwei_mom.data.check;

import androidx.databinding.BaseObservable;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/3/1  8:56
 */
public class CheckResult extends BaseObservable {

    /**
     * createBy :
     * createTime : 2024-02-27 15:05:30
     * updateBy :
     * updateTime : 2024-02-27 15:06:49
     * remark : null
     * checkResultDetailId : 17
     * checkResultId : 2
     * materialBarcode : 12
     * materialId : 2
     * checkRuleId : 1
     * checkRuleType : 3
     * checkRuleName : 规则1
     * checkMode : 2
     * checkSample : 1.0
     * checkStatus : 3
     * materialCode : null
     * materialName : null
     * poNo : null
     * saleorderCode : null
     */

    private int checkResultDetailId;
    private int checkResultId;
    private String materialBarcode;
    private int materialId;
    private int checkRuleId;
    private String checkRuleType;
    private String checkRuleName;
    private String checkMode;
    private double checkSample;
    private String checkStatus;
    private String materialCode;
    private String materialName;
    private String poNo;
    private String saleorderCode;
    private String materialType;


    private boolean visbleStatus=true;

    public boolean isVisbleStatus() {
        return visbleStatus;
    }

    public void setVisbleStatus(boolean visbleStatus) {
        this.visbleStatus = visbleStatus;
        notifyChange();
    }

    public String getMaterialType() {

        switch (materialType){
            case "1" : return "原材料";
            case "2" : return "半成品";
            case "3" : return "成品";
        }


        return null;
    }

    public void setMaterialType(String materialType) {
        this.materialType = materialType;
    }

    private List<CheckResultDetal> qmsCheckResultDetailProjectList;
    private List<CheckResultDetal> qmsCheckRuleProjectList;

    public List<CheckResultDetal> getQmsCheckRuleProjectList() {
        return qmsCheckRuleProjectList;
    }

    public void setQmsCheckRuleProjectList(List<CheckResultDetal> qmsCheckRuleProjectList) {
        this.qmsCheckRuleProjectList = qmsCheckRuleProjectList;
    }

    /**
     * 批次号
     */
    private String materialBatch;

    public String getMaterialBatch() {
        return materialBatch;
    }

    public void setMaterialBatch(String materialBatch) {
        this.materialBatch = materialBatch;
    }

    public int getCheckResultDetailId() {
        return checkResultDetailId;
    }



    public void setCheckResultDetailId(int checkResultDetailId) {
        this.checkResultDetailId = checkResultDetailId;
    }

    public int getCheckResultId() {
        return checkResultId;
    }

    public void setCheckResultId(int checkResultId) {
        this.checkResultId = checkResultId;
    }

    public String getMaterialBarcode() {
        return materialBarcode;
    }

    public void setMaterialBarcode(String materialBarcode) {
        this.materialBarcode = materialBarcode;
    }

    public int getMaterialId() {
        return materialId;
    }

    public void setMaterialId(int materialId) {
        this.materialId = materialId;
    }

    public int getCheckRuleId() {
        return checkRuleId;
    }

    public void setCheckRuleId(int checkRuleId) {
        this.checkRuleId = checkRuleId;
    }

    /**
     * 1来料检验,2,半成品检验，3成品检验,4工序检验
     * @return
     */
    public String getCheckRuleType() {
        switch (checkRuleType){
            case "1" : return "来料检验";
            case "2" : return "半成品检验";
            case "3" : return "成品检验";
            case "4" : return "工序检验";
        }
        return checkRuleType;
    }
    public String getCheckRuleTypeVel() {
        return checkRuleType;
    }

    public void setCheckRuleType(String checkRuleType) {
        this.checkRuleType = checkRuleType;
    }

    public String getCheckRuleName() {
        return checkRuleName;
    }

    public void setCheckRuleName(String checkRuleName) {
        this.checkRuleName = checkRuleName;
    }

    public String getCheckMode() {

        return checkMode.equals("1") ? "全检" : "抽检";
    }
    public String getCheckModeText() {

        return checkMode;
    }

    public void setCheckMode(String checkMode) {
        this.checkMode = checkMode;
    }

    public double getCheckSample() {
        return checkSample;
    }

    public void setCheckSample(double checkSample) {
        this.checkSample = checkSample;
    }

    public String getCheckStatus() {
        if (checkStatus==null) return "";
        switch (checkStatus) {
            case "0":
                setCheckStatus("待检验");
                break;
            case "1":
                setCheckStatus("检验中");
                break;
            case "2":
                setCheckStatus("质检通过");
                break;
            case "3":
                setCheckStatus("质检不通过");
                break;

        }

        return checkStatus;
    }

    public void setCheckStatus(String checkStatus) {
        this.checkStatus = checkStatus;
        notifyChange();
    }

    public String getMaterialCode() {
        return materialCode;
    }

    public void setMaterialCode(String materialCode) {
        this.materialCode = materialCode;
    }

    public String getMaterialName() {
        return materialName;
    }

    public void setMaterialName(String materialName) {
        this.materialName = materialName;
    }

    public String getPoNo() {
        return poNo;
    }

    public void setPoNo(String poNo) {
        this.poNo = poNo;
    }

    public String getSaleorderCode() {
        return saleorderCode;
    }

    public void setSaleorderCode(String saleorderCode) {
        this.saleorderCode = saleorderCode;
    }

    public List<CheckResultDetal> getQmsCheckResultDetailProjectList() {
        return qmsCheckResultDetailProjectList;
    }

    public void setQmsCheckResultDetailProjectList(List<CheckResultDetal> qmsCheckResultDetailProjectList) {
        this.qmsCheckResultDetailProjectList = qmsCheckResultDetailProjectList;
    }
}
