package com.example.haiwei_mom.data.check;

import android.text.Editable;
import android.util.Log;

import androidx.databinding.BaseObservable;

/**
 * @author wanghao
 * @date 2024/3/1  9:27
 */
public class CheckResultDetal extends BaseObservable  {

    private int index;

    /**
     * 质检结果详情项目信息ID
     */
    private Long resultDetailProjectId;
    /**
     * 质检结果详情ID，关联qms_check_result_detail的check_result_detail_id
     */
    private Long checkResultDetailId;
    /**
     * 检验项目ID，关联qms_check_project的check_project_id
     */
    private Long checkProjectId;
    /**
     * 检验结果(1合格,0不合格);定性需选择，定量的话根据检验结果的具体值自动选择
     */
    private String checkProjectStatus;
    /**
     * 检验结果,具体值
     */
    private String checkProjectResult;
    /**
     * 检验项目顺序
     */
    private Long projectStepOrder;
    /**
     * 标准值
     */
    private double standardValue;
    /**
     * 检验项目名称（冗余字段）
     */
    private String checkProjectName;
    /**
     * 检验项目属性(1定性,2定量),冗余字段
     */
    private String checkProjectProperty;
    /**
     * 上差值，检验时从检验项目复制过来的值
     */
    private double upperDiff;
    /**
     * 下差值，检验时从检验项目复制过来的值
     */
    private double downDiff;

    private String checkStatusShow;


    private String checkStatus;
    /** 创建者 */
    private String createBy;

    /** 创建时间 */
    private String createTime;

    private String materialCode;
    private String materialBarcode;

    public String getMaterialBarcode() {
        return materialBarcode;
    }

    public void setMaterialBarcode(String materialBarcode) {
        this.materialBarcode = materialBarcode;
    }

    public String getMaterialCode() {
        return materialCode;
    }

    public void setMaterialCode(String materialCode) {
        this.materialCode = materialCode;
    }

    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public String getCheckStatus() {
        switch (checkStatus) {
            case "0":
                setCheckStatus("待检验");
                break;
            case "1":
                setCheckStatus("检验中");
                break;
            case "2":
                setCheckStatus("质检通过");
                break;
            case "3":
                setCheckStatus("质检不通过");
                break;

        }
        return checkStatus;
    }

    public void setCheckStatus(String checkStatus) {
        this.checkStatus = checkStatus;
    }

    public int getIndex() {
        return index;
    }

    public void setIndex(int index) {
        this.index = index;
    }

    public Long getResultDetailProjectId() {
        return resultDetailProjectId;
    }

    public void setResultDetailProjectId(Long resultDetailProjectId) {
        this.resultDetailProjectId = resultDetailProjectId;
    }

    public Long getCheckResultDetailId() {
        return checkResultDetailId;
    }

    public void setCheckResultDetailId(Long checkResultDetailId) {
        this.checkResultDetailId = checkResultDetailId;
    }

    public Long getCheckProjectId() {
        return checkProjectId;
    }

    public void setCheckProjectId(Long checkProjectId) {
        this.checkProjectId = checkProjectId;
    }

    public String getCheckProjectStatus() {
        return checkProjectStatus;
    }

    public void setCheckProjectStatus(String checkProjectStatus) {
        this.checkProjectStatus = checkProjectStatus;
    }

    public String getCheckProjectResult() {
        return checkProjectResult;
    }

    public void setCheckProjectResult(String checkProjectResult) {
        this.checkProjectResult = checkProjectResult;
    }

    public Long getProjectStepOrder() {
        return projectStepOrder;
    }

    public void setProjectStepOrder(Long projectStepOrder) {
        this.projectStepOrder = projectStepOrder;
    }

    public double getStandardValue() {
        return standardValue;
    }

    public void setStandardValue(double standardValue) {
        this.standardValue = standardValue;
    }

    public String getCheckProjectName() {
        return checkProjectName;
    }

    public void setCheckProjectName(String checkProjectName) {
        this.checkProjectName = checkProjectName;
    }

    public String getCheckProjectProperty() {
        return checkProjectProperty;
    }

    public void setCheckProjectProperty(String checkProjectProperty) {
        this.checkProjectProperty = checkProjectProperty;
    }

    public double getUpperDiff() {
        return upperDiff;
    }

    public void setUpperDiff(double upperDiff) {
        this.upperDiff = upperDiff;
    }

    public double getDownDiff() {
        return downDiff;
    }

    public void setDownDiff(double downDiff) {
        this.downDiff = downDiff;
    }

    public String getCheckStatusShow() {
        if (checkProjectStatus==null||checkProjectStatus.isEmpty()){
            setCheckStatusShow("");
            // setCheckStatusShow("未检验");
        }else if (checkProjectStatus.equals("1")){
            setCheckStatusShow("合格");
        } else if (checkProjectStatus.equals("0")) {
            setCheckStatusShow("不合格");
        }

        return   checkStatusShow;
    }

    public void setCheckStatusShow(String checkStatusShow) {
        this.checkStatusShow = checkStatusShow;
        notifyChange();
    }

    public void click(String status){
        Log.e("TAG", "click:" + status);
        setCheckProjectStatus(status);
        // if (status.equals("1")){
        //     setCheckStatusShow("合格");
        // } else if (checkProjectStatus.equals("0")) {
        //     setCheckStatusShow("不合格");
        // }
    }
    public void textChanged(Editable s){
        double result=Double.parseDouble(s.toString());
        checkProjectResult=result+"";
        if (result>=downDiff && result<= upperDiff){
            setCheckProjectStatus("1");
        }else {
            setCheckProjectStatus("0");
        }
    }
}
