package com.example.haiwei_mom.data.device;

import android.util.Log;
import android.view.View;
import android.widget.AdapterView;

import androidx.databinding.BaseObservable;

import java.util.ArrayList;
import java.util.List;

/**
 * @author wanghao
 * @date 2024/3/22  14:46
 */
public class DeviceRepair extends BaseObservable {

    /**
     * repairInstanceId : 17
     * faultSourceType : 1
     * faultSourceId : 15
     * wfProcessId : 102
     * billsFaultCode : 202402281121
     * billsStatus : 2
     * applyUser : null
     * applyTime : 2024-02-28
     * realBeginTime : 2024-02-28
     * realEndTime : 2024-02-28
     * requireEndTime : 2024-02-29
     * instanceType : null
     * deviceCode : 22601
     * deviceName : 设备一号
     * deviceLocation : 一楼
     * deviceSpec : 111
     */

    private Long repairInstanceId;

    private Long faultSourceId;
    private Long wfProcessId;
    private String billsFaultCode;
    /**
     * 工单状态：0-待维修，1-维修中，2-维修完成
     */
    private String billsStatus;
    private String applyUser;
    private String applyTime;
    private String deviceCode;
    private String deviceName;
    //
    private String deviceLocation;
    private String deviceSpec;
    private String realBeginTime;
    private String realEndTime;
    private String requireEndTime;
    private String instanceType;
    // 显示数据

    private String billsStatusName;
    private boolean selectStatus;
    /**
     * isFlag : 1
     * instanceActivityId : null
     * faultType : 2
     * faultDescription : 故障测试修改
     * designOperations : 关火,断电
     */

    private String isFlag;
    private String faultType;
    private String faultDescription;
    private String designOperations;

    // 图片
    private List<InstanceFile> dmsInstanceFiles;

    // 提交
    private Long instanceActivityId;


    private int repairType;

    // 故障类别
    private String faultSourceType;
    private String faultSourceTypeName;

    // 外协单位
    private List<Outsourcing> outsourcingList;
    private List<String> outsourcingNameList;
    private int outsrcId;
    private int outsrcIdIndex;
    private String outsrcName;

    // 新增 待审批字段，1是待审批，2成功，3失败，不是2的情况下才可以修改，只有2的时候才可以开始
    private String approveStatus;
    public List<String> getOutsourcingNameList() {
        return outsourcingNameList;
    }

    public String getApproveStatus() {
        return approveStatus;
    }

    public void setApproveStatus(String approveStatus) {
        this.approveStatus = approveStatus;
    }

    public void setOutsourcingNameList(List<String> outsourcingNameList) {
        this.outsourcingNameList = outsourcingNameList;
        notifyChange();
    }

    public List<Outsourcing> getOutsourcingList() {
        return outsourcingList;
    }

    private String checkedFault;// 检查后的故障判断


    public void setOutsourcingList(List<Outsourcing> outsourcingList) {
        this.outsourcingList = outsourcingList;
        outsourcingNameList = new ArrayList<>(outsourcingList.size());
        for (int i = 0; i < outsourcingList.size(); i++) {
            Outsourcing outsourcing = outsourcingList.get(i);
            outsourcingNameList.add(outsourcing.getOutsrcName());
            if (outsourcing.getOutsrcId() == outsrcId) {
                // this.outsrcName=t.getOutsrcName();
                this.outsrcIdIndex = i;
                Log.e("TAG", "setOutsourcingList:" + i);
            }
        }
      /*          (t->{
         ;

        });*/
        notifyChange();
    }

    public int getOutsrcIdIndex() {

        return outsrcIdIndex;
    }

    public void selectOutSourcingID(AdapterView<?> parent, View view, int position, long id) {
        this.outsrcId = outsourcingList.get(position).getOutsrcId();
        this.outsrcIdIndex = position;
    }

    public String getOutsrcName() {
        return outsrcName;
    }

    public void setOutsrcName(String outsrcName) {
        this.outsrcName = outsrcName;
    }

    public String getFaultSourceTypeName() {
        return faultSourceTypeName;
    }

    public void setFaultSourceTypeName(String faultSourceTypeName) {
        this.faultSourceTypeName = faultSourceTypeName;
        notifyChange();
    }

    public int getRepairType() {

        return repairType;
    }

    public String getCheckedFault() {
        return checkedFault;
    }

    public void setCheckedFault(String checkedFault) {
        this.checkedFault = checkedFault;
    }

    public void setOutsrcIdIndex(int outsrcIdIndex) {
        this.outsrcIdIndex = outsrcIdIndex;
        notifyChange();
    }

    public void setRepairType(int repairType) {
        this.repairType = repairType;
    }

    private boolean radioState1;
    private boolean radioState2;

    public void repairTypeSelect(int type) {
        repairType = type;
        // radioState = (type == 2);
        if (type == 1) {

            setRadioState1(true);
            setRadioState2(false);
        } else {
            setRadioState1(false);
            setRadioState2(true);
        }

        // notifyChange();

    }

    public boolean isRadioState1() {
        return radioState1;
    }

    public void setRadioState1(boolean radioState1) {
        this.radioState1 = radioState1;
        notifyChange();
    }

    public boolean isRadioState2() {
        return radioState2;
    }

    public void setRadioState2(boolean radioState2) {
        this.radioState2 = radioState2;
        notifyChange();
    }

    public Long getInstanceActivityId() {
        return instanceActivityId;
    }

    public void setInstanceActivityId(Long instanceActivityId) {
        this.instanceActivityId = instanceActivityId;
    }

    public int getOutsrcId() {
        return outsrcId;
    }

    public void setOutsrcId(int outsrcId) {
        this.outsrcId = outsrcId;
    }

    public List<InstanceFile> getDmsInstanceFiles() {
        return dmsInstanceFiles;
    }

    public void setDmsInstanceFiles(List<InstanceFile> dmsInstanceFiles) {
        this.dmsInstanceFiles = dmsInstanceFiles;
    }

    public String getBillsStatusName() {
        switch (billsStatus) {
            case "0":
                return "待维修";
            case "1":
                return "维修中";
            case "2":
                return "维修完成";
        }

        return billsStatusName;
    }

    public boolean isSelectStatus() {
        try {
            // Log.e("TAG", billsFaultCode+"-" + billsStatus+"-"+approveStatus);
            if (billsStatus.equals("0")&& !approveStatus.equals("2")) {
                selectStatus = true;
            } else {
                selectStatus = false;
            }

        }catch (NullPointerException e){
            // e.printStackTrace();
            Log.e("TAG", "状态字段为null，单号:" +billsFaultCode );
            return false;
        }
        return selectStatus;
    }

    public Long getRepairInstanceId() {
        return repairInstanceId;
    }

    public void setRepairInstanceId(Long repairInstanceId) {
        this.repairInstanceId = repairInstanceId;
    }

    public String getFaultSourceType() {
        return faultSourceType;
    }

    public void setFaultSourceType(String faultSourceType) {
        this.faultSourceType = faultSourceType;

    }

    public Long getFaultSourceId() {
        return faultSourceId;
    }

    public void setFaultSourceId(Long faultSourceId) {
        this.faultSourceId = faultSourceId;
    }

    public Long getWfProcessId() {
        return wfProcessId;
    }

    public void setWfProcessId(Long wfProcessId) {
        this.wfProcessId = wfProcessId;
    }

    public String getBillsFaultCode() {
        return billsFaultCode;
    }

    public void setBillsFaultCode(String billsFaultCode) {
        this.billsFaultCode = billsFaultCode;
    }

    public String getBillsStatus() {
        return billsStatus;
    }

    public void setBillsStatus(String billsStatus) {
        this.billsStatus = billsStatus;
    }

    public String getApplyUser() {
        return applyUser;
    }

    public void setApplyUser(String applyUser) {
        this.applyUser = applyUser;
    }

    public String getApplyTime() {
        return applyTime;
    }

    public void setApplyTime(String applyTime) {
        this.applyTime = applyTime;
    }

    public String getRealBeginTime() {
        return realBeginTime;
    }

    public void setRealBeginTime(String realBeginTime) {
        this.realBeginTime = realBeginTime;
    }

    public String getRealEndTime() {
        return realEndTime;
    }

    public void setRealEndTime(String realEndTime) {
        this.realEndTime = realEndTime;
    }

    public String getRequireEndTime() {
        return requireEndTime;
    }

    public void setRequireEndTime(String requireEndTime) {
        this.requireEndTime = requireEndTime;
    }

    public String getInstanceType() {
        return instanceType;
    }

    public void setInstanceType(String instanceType) {
        this.instanceType = instanceType;
    }

    public String getDeviceCode() {
        return deviceCode;
    }

    public void setDeviceCode(String deviceCode) {
        this.deviceCode = deviceCode;
    }

    public String getDeviceName() {
        return deviceName;
    }

    public void setDeviceName(String deviceName) {
        this.deviceName = deviceName;
    }

    public String getDeviceLocation() {
        return deviceLocation;
    }

    public void setDeviceLocation(String deviceLocation) {
        this.deviceLocation = deviceLocation;
    }

    public String getDeviceSpec() {
        return deviceSpec;
    }

    public void setDeviceSpec(String deviceSpec) {
        this.deviceSpec = deviceSpec;
    }

    public String getIsFlag() {
        return isFlag;
    }

    public void setIsFlag(String isFlag) {
        this.isFlag = isFlag;
    }

    public String getFaultType() {
        return faultType;
    }

    public void setFaultType(String faultType) {
        this.faultType = faultType;
    }

    public String getFaultDescription() {
        return faultDescription;
    }

    public void setFaultDescription(String faultDescription) {
        this.faultDescription = faultDescription;
    }

    public String getDesignOperations() {
        return designOperations;
    }

    public void setDesignOperations(String designOperations) {
        this.designOperations = designOperations;
        notifyChange();
    }

    private String processHandleResolution;// 维修描述

    public String getProcessHandleResolution() {
        return processHandleResolution;
    }

    public void setProcessHandleResolution(String processHandleResolution) {
        this.processHandleResolution = processHandleResolution;
    }

    /**
     * 11-19新增字段
     * 点击开始保养后才可以输入提交
     */

    private String repairContent; // 维修内容
    private String protectedMethod;// 保护措施
    private List<DeviceRepairPart> parts;// 所用零部件
    private List<InstanceFile> dmsInstanceFiles1;//维修完成的图片

    public List<InstanceFile> getDmsInstanceFiles1() {
        return dmsInstanceFiles1;
    }

    public void setDmsInstanceFiles1(List<InstanceFile> dmsInstanceFiles1) {
        this.dmsInstanceFiles1 = dmsInstanceFiles1;
    }

    public List<DeviceRepairPart> getParts() {
        return parts;
    }

    public void setParts(List<DeviceRepairPart> parts) {
        this.parts = parts;
    }

    public String getRepairContent() {
        return repairContent;
    }

    public void setRepairContent(String repairContent) {
        this.repairContent = repairContent;
    }

    public String getProtectedMethod() {
        return protectedMethod;
    }

    public void setProtectedMethod(String protectedMethod) {
        this.protectedMethod = protectedMethod;
    }

    /**
     * 修改 增加
     */
    private String deviceCodeTag;// 开始前 验证的设备编码

    public String getDeviceCodeTag() {
        return deviceCodeTag;
    }

    public void setDeviceCodeTag(String deviceCodeTag) {
        this.deviceCodeTag = deviceCodeTag;
        notifyChange();
    }


}
