package com.example.haiwei_mom.device;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;

import androidx.databinding.DataBindingUtil;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.ItemClickCall;
import com.example.haiwei_mom.adapter.device.DeviceInspectiontAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.databinding.ActivityDeviceCheckBinding;
import com.example.haiwei_mom.data.device.DeviceInspection;
import com.example.haiwei_mom.data.device.DeviceInspectionDetail;
import com.example.haiwei_mom.uitls.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

public class DeviceCheckActivity extends BaseActivity implements ItemClickCall {
    private DeviceInspection deviceInspection;
    private List<DeviceInspectionDetail> list;
    private DeviceInspectiontAdapter adapter;

    private  ActivityDeviceCheckBinding binding;
    private Intent intent;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this,R.layout.activity_device_check);
        adapter=new DeviceInspectiontAdapter(this,this);
        binding.setAdapter(adapter);

        intent=new Intent(this, DeviceCheckInfoActivity.class);
    }

    @Override
    protected void onResume() {
        super.onResume();
        initRequest();
    }

    private void initRequest() {
        OkGo.<MyResult>get(url+ "/dms/mobile/getNewestInspectInstance").tag(this)
                .params("inspectType",1/*getIntent().getStringExtra("inspectType")*/)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            deviceInspection=  gson.fromJson(body.getData().toString(), DeviceInspection.class);
                            binding.setVm(deviceInspection);
                            list=deviceInspection.getDmsInspectInstanceDetailList();
                            adapter.setList(list);
                            adapter.notifyDataSetChanged();
                        }
                    }
                });
    }

    @Override
    public void onClick(int position) {

    }

    public void deviceCheckSelect(View view){

    }
    public void deviceCheckStart(View view){
        var code = binding.inspectionDeviceCode.getText().toString().trim();
        if (code==null || code.isEmpty()) return;
        OkGo.<MyResult>get(url+ "/dms/mobile/scanInspectInstanceDetail").tag(this)
                .params("inspectInstanceId",deviceInspection.getInspectInstanceId())
                .params("deviceCode",code)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            intent.putExtra("json",body.getData().toString());
                            startActivity(intent);
                        }
                    }
                });
    }

}