package com.example.haiwei_mom.device;

import android.os.Bundle;
import android.view.View;

import androidx.databinding.DataBindingUtil;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.device.DeviceInspectionInfoAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.databinding.ActivityDeviceCheckInfoBinding;
import com.example.haiwei_mom.data.device.DeviceInspectionDetail;
import com.example.haiwei_mom.uitls.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import okhttp3.RequestBody;

public class DeviceCheckInfoActivity extends BaseActivity {
    private DeviceInspectionDetail detail;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityDeviceCheckInfoBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_device_check_info);
        detail = gson.fromJson(getIntent().getStringExtra("json"), DeviceInspectionDetail.class);
        binding.setVm(detail);
        var list = detail.getDmsInspectInstanceDetailProjectList();
        // Log.e("TAG", "onCreate:" + list.toString());
        DeviceInspectionInfoAdapter adapter =new DeviceInspectionInfoAdapter(this,list);
        binding.setAdapter(adapter);
        adapter.notifyDataSetChanged();
    }
    public void deviceCheckInfoSubmit(View view){
        OkGo.<MyResult>post(url+"/dms/mobile/saveInspectInstanceDetail")
                .upRequestBody(RequestBody.create(JSON,gson.toJson(detail)))
                .execute(new MyRecultCall(dialog,this){
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            finish();
                        }
                        myToastUitls.show( body.getMsg());
                    }
                });
    }
}