package com.example.haiwei_mom.device;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListPopupWindow;

import androidx.databinding.DataBindingUtil;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.check.DisposalFileAdapter;
import com.example.haiwei_mom.adapter.device.DeviceRepairPartAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.databinding.ActivityDeviceRepairInfoBinding;
import com.example.haiwei_mom.dialog.ImgDialog;
import com.example.haiwei_mom.dialog.RepairPartAddDialog;
import com.example.haiwei_mom.data.check.CheckInstanceFiles;
import com.example.haiwei_mom.data.device.DeviceRepair;
import com.example.haiwei_mom.data.device.DeviceRepairPart;
import com.example.haiwei_mom.data.device.Dict;
import com.example.haiwei_mom.data.device.Outsourcing;
import com.example.haiwei_mom.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

import okhttp3.RequestBody;

public class DeviceRepairInfoActivity extends BaseActivity {

    private ImgDialog imgDialog;
    private DisposalFileAdapter fileAdapter;
    private ActivityDeviceRepairInfoBinding binding;
    private DeviceRepair deviceRepair;// 显示数据
    private boolean activityType;// 活动状态 true修改 false查看
    private ListPopupWindow faultTypeLpw;
    private ListPopupWindow opeLpw;
    private List<Dict> faultList;
    private List<Dict> opeList;
    // 图片
    private List<File> submitFileList;
    private List<CheckInstanceFiles> filesList;
    private int fileTagIndex = 0;
    // 维修部件
    private DeviceRepairPartAdapter deviceRepairPartAdapter;
    private RepairPartAddDialog repairPartAddDialog;// 添加
    // 维修完成拍照
    private List<CheckInstanceFiles> overRepairLookList;// 显示列表
    private DisposalFileAdapter fileAdapter2;

    @SuppressLint("NotifyDataSetChanged")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_device_repair_info);
        var intent = getIntent();
        activityType = intent.getBooleanExtra("activityType", false);
        binding.setVisState(activityType);
        // 主要
        deviceRepair = gson.fromJson(intent.getStringExtra("json"), DeviceRepair.class);
        initfaultTypeSelect();
        initopeSelect();
        initRequest("dms_fault_type");
        binding.setVm(deviceRepair); // 显示数据
        deviceRepair.repairTypeSelect(deviceRepair.getRepairType());// 显示维修类型
        if (activityType) {  // 报修修改
            initRequest("dms_device_design_operations");

        } else {// 显示完成
            var billsStatus = deviceRepair.getBillsStatus();
            if (billsStatus.equals("0")) {
                if (deviceRepair.getApproveStatus() != null && deviceRepair.getApproveStatus().equals("2")) {
                    binding.setStartState(true);
                }
            } else if (billsStatus.equals("1")) {
                binding.setSubmitState(true);
                binding.setOverState(true);
            } else if (billsStatus.equals("2")) {
                binding.setSubmitState(true);
            }


            deviceRepairPartAdapter = new DeviceRepairPartAdapter(this, position -> {
                deviceRepair.getParts().remove(position);
                deviceRepairPartAdapter.notifyDataSetChanged();
            });
            deviceRepairPartAdapter.setList(deviceRepair.getParts());
            binding.setPartAdapter(deviceRepairPartAdapter);
            repairPartAddDialog = new RepairPartAddDialog(this, deviceRepairPart -> {
                DeviceRepairPart addTag = new DeviceRepairPart();
                addTag.setAmount(deviceRepairPart.getAmount());
                addTag.setPartName(deviceRepairPart.getPartName());
                addTag.setPartSpecifications(deviceRepairPart.getPartSpecifications());
                deviceRepair.getParts().add(addTag);
                repairPartAddDialog.dismiss();
                deviceRepairPartAdapter.notifyDataSetChanged();
            });
            // 显示维修完成的图片
            var dmsInstanceFiles1 = deviceRepair.getDmsInstanceFiles1();
            overRepairLookList = new ArrayList<>();
            if (dmsInstanceFiles1 != null && !dmsInstanceFiles1.isEmpty()) {
                dmsInstanceFiles1.stream().forEach(t -> {
                    CheckInstanceFiles files = new CheckInstanceFiles();
                    files.setFaultFile(t.getFilePath());
                    files.setState(false);
                    overRepairLookList.add(files);
                });
            }

            // 维修完成的图片

            fileAdapter2 = new DisposalFileAdapter(this, (position, type) -> {
                CheckInstanceFiles checkInstanceFiles = overRepairLookList.get(position);
                if (type) {
                    imgDialog.setRawReturn(checkInstanceFiles.getFaultFile());
                    return;
                }
                overRepairLookList.remove(position);
                try {
                    int index = position - fileTagIndex;
                    Log.e("TAG", "file List delete:" + index);
                    submitFileList.get(index).delete();
                    submitFileList.remove(index);
                } catch (Exception er) {
                    er.printStackTrace();
                }

                fileAdapter2.notifyDataSetChanged();
            });
            fileAdapter2.setList(overRepairLookList);
            fileAdapter2.notifyDataSetChanged();
            binding.setAdapter2(fileAdapter2);
        }

        outStrRequest(); // 查询外协

        initFile(); // 初始化图片

    }

    private void initopeSelect() {
        opeLpw = new ListPopupWindow(context);
        opeLpw.setAnchorView(binding.operations);
        opeLpw.setOnItemClickListener((parent, view, position, id) -> {
            String designOperations = deviceRepair.getDesignOperations();
            var addStr = opeList.get(position).getDictLabel();
            if (designOperations != null && designOperations.contains(addStr)) {
                String tagStr = null;
                if (designOperations.indexOf(addStr) == 0) {
                    tagStr = addStr + ",";
                } else {
                    tagStr = "," + addStr;
                }
                designOperations = designOperations.replace(tagStr, "").replace(addStr, "");
                deviceRepair.setDesignOperations(designOperations);
            } else {
                deviceRepair.setDesignOperations(Optional.ofNullable(designOperations).map(t -> t.isEmpty() ? t : t + ",").orElse("") + addStr);
            }
            opeLpw.dismiss();
        });
    }

    private void initfaultTypeSelect() {
        faultTypeLpw = new ListPopupWindow(context);
        faultTypeLpw.setAnchorView(binding.faultType);
        faultTypeLpw.setOnItemClickListener((parent, view, position, id) -> {
            Dict dict = faultList.get(position);
            deviceRepair.setFaultSourceTypeName(dict.getDictLabel());
            Log.e("TAG", "onCreate:" + dict.getDictValue());
            deviceRepair.setFaultSourceType(dict.getDictValue());
            faultTypeLpw.dismiss();
        });
    }

    private void initFile() {
        fileAdapter = new DisposalFileAdapter(this, (position, type) -> {
            CheckInstanceFiles checkInstanceFiles = filesList.get(position);
            if (type) {
                imgDialog.setRawReturn(checkInstanceFiles.getFaultFile());
                return;
            }
            filesList.remove(position);
            try {
                int index = position - fileTagIndex;
                Log.e("TAG", "file List delete:" + index);
                submitFileList.get(index).delete();
                submitFileList.remove(index);
            } catch (Exception er) {
                er.printStackTrace();
            }

            fileAdapter.notifyDataSetChanged();
        });
        filesList = new ArrayList<>();
        submitFileList = new ArrayList<>();
        var dmsInstanceFiles = deviceRepair.getDmsInstanceFiles();
        if (dmsInstanceFiles != null && !dmsInstanceFiles.isEmpty()) {
            dmsInstanceFiles.forEach(t -> {
                CheckInstanceFiles files = new CheckInstanceFiles();
                files.setFaultFile(t.getFilePath());
                files.setState(false);
                filesList.add(files);
            });
            fileTagIndex = filesList.size();
        }
        fileAdapter.setList(filesList);
        binding.setAdapter1(fileAdapter);
        imgDialog = new ImgDialog(this);
    }

    // 查询故障 和 ope接口
    private void initRequest(String uri) {
        OkGo.<MyResult>get(url + "/dms/mobile/dict/type/" + uri).tag(this)
                .execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getCode() == 200) {
                    List<Dict> list = gson.fromJson(body.getData().toString(), new TypeToken<List<Dict>>() {
                    }.getType());
                    List<String> strings = new ArrayList<>();
                    list.forEach(t -> strings.add(t.getDictLabel()));
                    if (uri.equals("dms_fault_type")) {
                        // 显示故障类别
                        String faultSourceType = deviceRepair.getFaultSourceType();
                        if (faultSourceType != null) {
                            Optional<String> s = list.stream().filter(t -> t.getDictValue().equals(faultSourceType)).findFirst().map(Dict::getDictLabel);
                            deviceRepair.setFaultSourceTypeName(s.get());
                        }
                        if (activityType) {
                            faultList = new ArrayList<>();
                            faultList.addAll(list);
                            faultTypeLpw.setAdapter(new ArrayAdapter<>(context, androidx.appcompat.R.layout.support_simple_spinner_dropdown_item, strings));
                        }
                    } else {
                        opeList = new ArrayList<>();
                        opeList.addAll(list);
                        opeLpw.setAdapter(new ArrayAdapter<>(context, androidx.appcompat.R.layout.support_simple_spinner_dropdown_item, strings));
                    }


                }
            }
        });

    }


    // 开始维修
    public void startRepair(View view) {
        String deviceCodeTag = deviceRepair.getDeviceCodeTag();
        if (deviceCodeTag == null) {
            myToastUitls.show("数据异常");
            return;
        }
        if (!deviceRepair.getDeviceCode().equals(deviceCodeTag)) {
            myToastUitls.show("设备扫描错误");
            return;
        }
        OkGo.<MyResult>post(url + "/dms/mobile/startRepair").headers("Authorization", SharedPreferencesUtils.getstring("access_token", "")).upRequestBody(RequestBody.create(JSON, gson.toJson(deviceRepair))).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                if (response.body().getCode() == 200) {
                    binding.setSubmitState(true);
                    binding.setOverState(true);
                    binding.setStartState(false);
                }
            }
        });
    }


    // 完成维修
    public void endRepair(View view) {
        // try {
        //     Log.e("TAG", "repairInstanceId" + deviceRepair.getRepairInstanceId());
        //     Log.e("TAG", "instanceActivityId" + deviceRepair.getInstanceActivityId());

            OkGo.<MyResult>post(url + "/dms/mobile/completeRepair")
                    .params("repairInstanceId", deviceRepair.getRepairInstanceId())
                    .params("instanceActivityId", deviceRepair.getInstanceActivityId())
                    .params("designOperations", deviceRepair.getDesignOperations())
                    .params("faultType", deviceRepair.getFaultSourceType())
                    .params("processHandleResolution", deviceRepair.getProcessHandleResolution())
                    .params("repairType", deviceRepair.getRepairType())
                    .params("outsrcId", deviceRepair.getOutsrcId())
                    .params("repairContent", deviceRepair.getRepairContent())
                    .params("protectedMethod", deviceRepair.getProtectedMethod())
                    .params("repairer", SharedPreferencesUtils.getstring("user", ""))
                    .params("parts1", gson.toJson(deviceRepair.getParts()))
                    .addFileParams("files", submitFileList)
                    .execute(new MyRecultCall(dialog, this) {
                        @Override
                        public void onSuccess(Response<MyResult> response) {
                            MyResult body = response.body();
                            if (body.getCode() == 200) {
                                submitFileList.forEach(File::delete);
                                finish();
                            } else {
                                myToastUitls.show(body.getMsg());
                            }
                        }
                    });
        // } catch (Exception e) {
        //     e.printStackTrace();
        // }

    }

    // 选择故障类别
    public void selectFaultType(View view) {
        faultTypeLpw.show();
    }

    // 选择涉及操作
    public void selectOperation(View view) {
        opeLpw.show();
    }

    // 查询外协
    private void outStrRequest() {
        OkGo.<MyResult>get(url + "/dms/mobile/getOutsrcInfos").tag(this)
                .execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getCode() == 200) {
                    List<Outsourcing> outsourcingList = gson.fromJson(body.getData().toString(), new TypeToken<List<Outsourcing>>() {
                    }.getType());
                    deviceRepair.setOutsourcingList(outsourcingList);
                    return;
                }

            }
        });
    }

    // 拍照
    public void updateTackphoto(View view) {
        try {
            teke_photo();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    // 拍照 维修完成
    public void overRepairTackphoto(View view) {
        try {
            teke_photo();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    // 拍照回传
    @SuppressLint("NotifyDataSetChanged")
    @Override
    public void tekePhotoResult(String fileUrl, File file) {
        super.tekePhotoResult(fileUrl, file);
        CheckInstanceFiles checkInstanceFiles = new CheckInstanceFiles();
        checkInstanceFiles.setFaultFile(fileUrl);
        checkInstanceFiles.setState(true);
        submitFileList.add(file);
        if (activityType) {
            // 修改时添加到上方
            filesList.add(checkInstanceFiles);
            fileAdapter.notifyDataSetChanged();

        } else {
            // 查看时，添加到维修完成的列表
            overRepairLookList.add(checkInstanceFiles);
            fileAdapter2.notifyDataSetChanged();
        }

    }


    // 提交修改 维修工单
    public void submitUpdateRepair(View view) {
        Log.e("TAG", "submitUpdateRepair:" + deviceRepair.getInstanceActivityId());
        int repairType = deviceRepair.getRepairType();
        OkGo.<MyResult>post(url + "/dms/mobile/updateFaultInstanceActivity")
                .params("instanceActivityId", deviceRepair.getInstanceActivityId())
                .params("faultSourceType", deviceRepair.getFaultSourceType())
                .params("faultDescription", deviceRepair.getFaultDescription())
                .params("designOperations", deviceRepair.getDesignOperations())
                .params("repairType", repairType)
                .params("checkedFault", deviceRepair.getCheckedFault())
                .params("outsrcId", deviceRepair.getOutsrcId())
                .addFileParams("files", submitFileList).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getCode() == 200) {
                    if (!submitFileList.isEmpty()) {
                        submitFileList.forEach(File::delete);
                    }
                    finish();
                }
                myToastUitls.show(body.getMsg());
            }
        });
    }

    public void addRepairPart(View view) {
        repairPartAddDialog.show();
    }

}