package com.example.haiwei_mom.device;

import android.os.Bundle;

import androidx.databinding.DataBindingUtil;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.ItemClickCall;
import com.example.haiwei_mom.adapter.device.LubricationAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.databinding.ActivityLubricationBinding;
import com.example.haiwei_mom.data.device.LubricationBeen;
import com.example.haiwei_mom.data.device.LubricationDetail;
import com.example.haiwei_mom.uitls.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import okhttp3.RequestBody;

public class LubricationActivity extends BaseActivity implements ItemClickCall {
    private LubricationAdapter adapter;
    private List<LubricationDetail> list;
    private ActivityLubricationBinding binding;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        binding = DataBindingUtil.setContentView(this, R.layout.activity_lubrication);
        adapter = new LubricationAdapter(this, this);
        binding.setAdapter(adapter);
        initRequest();
    }

    private void initRequest() {
        OkGo.<MyResult>get(url + "/dms/mobile/getNewestLubeInstance").tag(this)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            LubricationBeen been = gson.fromJson(body.getData().toString(), LubricationBeen.class);

                            binding.setVm(been);
                            list = been.getDmsBillsLubeDetailList();
                            adapter.setList(list);
                            adapter.notifyDataSetChanged();
                        }
                    }
                });
    }

    @Override
    public void onClick(int position) {
        var maintainDetail = list.get(position);
        var uri = maintainDetail.getButtonText().equals("开始润滑") ? "/dms/mobile/startLube" : "/dms/mobile/completeLube";
        Map<String,String> map=new HashMap<>();

        OkGo.<MyResult>post(url + uri)
                .upRequestBody(RequestBody.create(JSON, gson.toJson(maintainDetail)))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            initRequest();
                            return;
                        }
                        myToastUitls.show( body.getMsg());
                    }
                });
    }
}