package com.example.haiwei_mom.device;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.View;

import androidx.databinding.DataBindingUtil;
import androidx.databinding.ObservableBoolean;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.device.MaintainProjectAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.databinding.ActivityMaintainInfoBinding;
import com.example.haiwei_mom.data.device.MaintainDetail;
import com.example.haiwei_mom.data.device.MaintainProject;
import com.example.haiwei_mom.uitls.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import okhttp3.RequestBody;

public class MaintainInfoActivity extends BaseActivity {
    private MaintainProjectAdapter adapter;
    private List<MaintainProject> list;
    private MaintainDetail maintainDetail;
    private ObservableBoolean state;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityMaintainInfoBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_maintain_info);
        adapter = new MaintainProjectAdapter(this);
        binding.setAdapter(adapter);
        state = new ObservableBoolean();
        state.set(false);
        binding.setState(state);
        // var uri = maintainDetail.getButtonText().equals("开始保养") ? "" : "/dms/mobile/completeMaint";
        OkGo.<MyResult>post(url + "/dms/mobile/startMaint")
                .upRequestBody(RequestBody.create(JSON, getIntent().getStringExtra("json")))
                .execute(new MyRecultCall(dialog, this) {
                    @SuppressLint("NotifyDataSetChanged")
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            maintainDetail = gson.fromJson(body.getData().toString(), MaintainDetail.class);
                            state.set(maintainDetail.getMaintStatus() == 3);
                            list = maintainDetail.getDmsBillsMaintDetailProjectList();
                            adapter.setList(list);
                            adapter.notifyDataSetChanged();
                            return;
                        }
                        myToastUitls.show( body.getMsg());
                    }
                });

    }


    public void maintainInfoSubmit(View view) {
        OkGo.<MyResult>post(url + "/dms/mobile/completeMaint")
                .upRequestBody(RequestBody.create(JSON, gson.toJson(maintainDetail))).execute(new MyRecultCall(dialog, this) {
            @SuppressLint("NotifyDataSetChanged")
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getCode() == 200) {
                    finish();
                    return;
                }
                myToastUitls.show( body.getMsg());
            }
        });
    }
}