package com.example.haiwei_mom.wms.product;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import androidx.databinding.DataBindingUtil;
import androidx.databinding.ObservableInt;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.BindVehicleAdapter;
import com.example.haiwei_mom.adapter.ItemClickCall;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.BaseToolingInfo;
import com.example.haiwei_mom.data.TyreInfo;
import com.example.haiwei_mom.databinding.ActivityBindVehicleBinding;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.List;

public class BindVehicleActivity extends BaseActivity implements ItemClickCall {
    boolean sanState = true;
    private ActivityBindVehicleBinding binding;
    private ArrayList<String> list;
    private BindVehicleAdapter adapter;
    private ObservableInt listSize;
    private List<TyreInfo> tyreInfoList;
    private  BaseToolingInfo baseToolingInfo;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_bind_vehicle);
        list = new ArrayList<>();
        listSize = new ObservableInt();
        binding.setSize(listSize);
        adapter = new BindVehicleAdapter(this, this);
        adapter.setList(list);
        binding.setAdapter(adapter);
        binding.bindVehicleCode.setOnEditorActionListener((v, actionId, event) -> {
            selectVehicle(v.getText().toString());
            return true;
        });

         binding.bindProductCode.setOnEditorActionListener((v, actionId, event) -> {
             selectTyre(v.getText().toString());
            return true;
        });


    }

    // 查询工装
    private void selectVehicle(String code) {
        OkGo.<MyResult>post(url + "/wms/pda/product/selectVehicle")
                .params("code", code)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        binding.setCode2(null);
                        if (body.getCode() == 200) {

                            baseToolingInfo = gson.fromJson(body.getDataJson(), BaseToolingInfo.class);
                            binding.setCode2(baseToolingInfo.getToolingCode());
                            sanState = false;
                            tyreInfoList=new ArrayList<>();
                            baseToolingInfo.setTyreInfoList(tyreInfoList);

                        }
                        myToastUitls.show(body.getMsg());
                    }
                });

    }

    // 查询轮胎
    private void selectTyre(String code) {
        OkGo.<MyResult>post(url + "/wms/pda/product/selectTyreCode")
                .params("code", code)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            TyreInfo tyreInfo= gson.fromJson(body.getDataJson(), TyreInfo.class);
                            String data = tyreInfo.getReturnBarcode();
                            if (list.contains(data)) {
                                return;
                            }
                            Log.e("TAG", "getScannerData:" + listSize.get());
                            list.add(data);
                            adapter.notifyDataSetChanged();
                            listSize.set(list.size());
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });

    }



    @SuppressLint("NotifyDataSetChanged")
    @Override
    public void getScannerData(String data) {
        super.getScannerData(data);
        if (sanState) {
            binding.bindVehicleCode.setText(data);
            selectVehicle(data);
            return;
        }

    }

    @SuppressLint("NotifyDataSetChanged")
    @Override
    public void onClick(int position) {
        list.remove(position);
        adapter.notifyDataSetChanged();
        listSize.set(list.size());
    }

    public void bindVehicleSubmit(View view) {
        OkGo.<MyResult>post(url + "/wms/pda/product/bindVehicleSubmit")
                .params("vehicleCode", binding.bindVehicleCode.getText().toString())
                .addUrlParams("productList", list)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            finish();
                            return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }
}