package com.example.haiwei_mom.wms.raw;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.graphics.NinePatch;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Toast;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.CheckWorkAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.CheckRecordVo;
import com.example.haiwei_mom.data.WmsInventoryCheck;
import com.example.haiwei_mom.data.WmsInventoryVo;
import com.example.haiwei_mom.databinding.ActivityCheckWorkBinding;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.Arrays;
import java.util.List;
import java.util.Objects;

import okhttp3.RequestBody;

public class CheckWorkActivity extends BaseActivity {
    private List<String> list;
    private List<WmsInventoryVo> inventorylist;
    private CheckWorkAdapter checkWorkAdapter;
    private CheckRecordVo checkRecordVo;
    private String checkCode;
    private String type;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityCheckWorkBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_check_work);
        Intent intent = getIntent();
        list = Arrays.asList(intent.getStringArrayExtra("list"));
        binding.setList(list);
        checkCode = intent.getStringExtra("code");
        type = intent.getStringExtra("type");
        binding.setCode(checkCode);
        binding.workListSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                selectInventory(list.get(position));
            }


            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        checkWorkAdapter = new CheckWorkAdapter(this);
        binding.setAdapter(checkWorkAdapter);
        checkRecordVo = new CheckRecordVo();
        checkRecordVo.setCheckCode(checkCode);
        binding.setData(checkRecordVo);
    }

    private void selectInventory(String locationCode) {
        OkGo.<MyResult>post(url + "/wms/pda/storeCheck/selectInventory")
                .params("locationCode", locationCode)
                .params("type", type)
                .execute(new MyRecultCall(dialog, this) {
                    @SuppressLint("NotifyDataSetChanged")
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            inventorylist = gson.fromJson(body.getDataJson(), new TypeToken<List<WmsInventoryVo>>() {
                            }.getType());
                            checkWorkAdapter.setList(inventorylist);
                            checkWorkAdapter.notifyDataSetChanged();
                            return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }

    // 完成
    public void storeCheckWorkOver(View view) {
        OkGo.<MyResult>post(url + "/wms/pda/storeCheck/storeCheckWorkOver")
                .params("checkCode", checkCode)
                .execute(new MyRecultCall(dialog, this) {

                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            finish();
                            Toast.makeText(CheckWorkActivity.this, "提交成功", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }

    // 提交
    public void storeCheckWork(View view) {
        String batchCode = checkRecordVo.getBatchCode();
        WmsInventoryVo wmsInventoryVo = inventorylist.stream().filter(t -> t.getBatchCode().equals(batchCode)).findFirst().get();

        checkRecordVo.setMaterialCode(wmsInventoryVo.getMaterialCode());
        checkRecordVo.setLocationCode(wmsInventoryVo.getLocationCode());
        checkRecordVo.setInventoryQty(wmsInventoryVo.getInventoryQty());
        checkRecordVo.setMaterialName(wmsInventoryVo.getMaterialName());
        OkGo.<MyResult>post(url + "/wms/pda/storeCheck/submitCheckRecord")
                .upRequestBody(RequestBody.create(JSON, gson.toJson(checkRecordVo)))
                .execute(new MyRecultCall(dialog, this) {

                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            checkRecordVo.setCheckQty("");
                            checkRecordVo.setBatchCode("");
                            Toast.makeText(CheckWorkActivity.this, "提交成功", Toast.LENGTH_SHORT).show();
                            return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });

    }
}