package com.example.haiwei_mom.wms.raw;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.RawInstock;
import com.example.haiwei_mom.databinding.ActivityRawInBinding;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import okhttp3.RequestBody;

public class RawInActivity extends BaseActivity implements View.OnFocusChangeListener {
    private RawInstock rawInstock;
    private ActivityRawInBinding binding;
    private EditText editTextView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_raw_in);
        binding.materialInLocation.setOnFocusChangeListener(this);
        binding.materialInGoods.setOnFocusChangeListener(this);
    }

    @Override
    public void getScannerData(String data) {
        super.getScannerData(data);
        if (editTextView == binding.materialInLocation) {
            editTextView.setText(data);

        } else if (editTextView == binding.materialInGoods || rawInstock == null) {
            binding.materialInGoods.setText(data);
            OkGo.<MyResult>post(url + "/wms/pda/raw/inSelectCode").params("code", data).execute(new MyRecultCall(dialog, this) {
                @Override
                public void onSuccess(Response<MyResult> response) {
                    super.onSuccess(response);
                    var body = response.body();
                    if (body.getCode() == 200) {
                        rawInstock = gson.fromJson(body.getDataJson(), RawInstock.class);
                        binding.setData(rawInstock);
                        return;
                    }

                    myToastUitls.show(body.getMsg());
                }
            });
        }


    }

    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        if (hasFocus) {
            editTextView = (EditText) v;
        }
    }

    public void rawinSubmit(View view) {
        if (rawInstock == null) {
            return;
        }
        var instockQty = rawInstock.getInstockQty();
        if (instockQty == null || instockQty.isEmpty()) return;

        var parseDouble = Double.parseDouble(instockQty);
        if (parseDouble > rawInstock.getMaterialQty()) {
            myToastUitls.show("输入数量不能超过条码数量");
            return;
        }
        OkGo.<MyResult>post(url + "/wms/pda/raw/inSubmit").upRequestBody(RequestBody.create(JSON, gson.toJson(rawInstock))).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getCode() == 200) {
                    rawInstock.setInstockQty(null);
                    rawInstock.setLocationCode(null);
                    rawInstock.setMaterialQty(rawInstock.getMaterialQty() - parseDouble);
                    // finish();
                    Toast.makeText(RawInActivity.this, "入库成功", Toast.LENGTH_SHORT).show();
                    return;
                }
                myToastUitls.show(body.getMsg());
            }
        });
    }
}