package com.example.haiwei_mom.wms.raw;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.widget.EditText;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.RawOutDetailAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.OutDetail;
import com.example.haiwei_mom.data.RawOutSubmitBeen;
import com.example.haiwei_mom.databinding.ActivityRawOutBinding;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import okhttp3.RequestBody;

public class RawOutActivity extends BaseActivity implements View.OnFocusChangeListener {
    private ActivityRawOutBinding binding;
    private RawOutDetailAdapter rawOutDetailAdapter;
    private EditText rawOutCodeView;
    private EditText rawOutLocationView;
    private EditText rawOutGoodsView;
    private EditText focusView;
    private boolean sanState = true;
    private RawOutSubmitBeen submitBeen;
    @SuppressLint("ClickableViewAccessibility")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        binding = DataBindingUtil.setContentView(this, R.layout.activity_raw_out);
        rawOutCodeView = binding.rawOutCode;
        rawOutCodeView.setOnTouchListener((v, event) -> {
            if (event.getAction() == MotionEvent.ACTION_UP) {
                // 获取触摸的位置
                int x = (int) event.getX();
                if (x >= 464) {
                    selectOutOrderCode(binding.rawOutCode.getText().toString());
                    return true;
                }
            }
            return false;
        });

        rawOutLocationView = binding.rawOutLocation;
        rawOutLocationView.setOnFocusChangeListener(this);
        rawOutGoodsView = binding.rawOutGoods;
        rawOutGoodsView.setOnFocusChangeListener(this);

        rawOutDetailAdapter = new RawOutDetailAdapter(this);
        binding.setDetailAdapter(rawOutDetailAdapter);
        submitBeen=new RawOutSubmitBeen();
        binding.setSubBeen(submitBeen);
    }

    private void selectOutOrderCode(String orderCode) {
        OkGo.<MyResult>post(url + "/wms/pda/raw/outSelectByOrderCode").params("orderCode", orderCode).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getCode() == 200) {
                    List<OutDetail> list = gson.fromJson(body.getDataJson(), new TypeToken<List<OutDetail>>() {
                    }.getType());
                    rawOutDetailAdapter.setList(list);
                    rawOutDetailAdapter.notifyDataSetChanged();
                    sanState = false;
                    return;
                }
                sanState = true;
                myToastUitls.show(body.getMsg());
            }
        });
    }


    @Override
    public void getScannerData(String data) {
        super.getScannerData(data);

        if (sanState) {
            rawOutCodeView.setText(data);
            selectOutOrderCode(data);
            return;
        }
        if (focusView == rawOutLocationView) {
            rawOutLocationView.setText(data);
        } else if (focusView == rawOutGoodsView) {
            rawOutGoodsView.setText(data);
            // selectBacthCode(data, rawOutLocationView.getText().toString());
        }


    }



    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        if (hasFocus) {
            focusView = (EditText) v;
        }
    }

    public void rawOutSubmit(View view){
        if (submitBeen.getLocationCode()==null||submitBeen.getBatchCode()==null||submitBeen.getOutstockQty()==null) {
            return;
        }
        OkGo.<MyResult>post(url + "/wms/pda/raw/selectInVentoryByBatchCode")
                .upRequestBody(RequestBody.create(JSON,gson.toJson(submitBeen)))
                .execute(new MyRecultCall(dialog, this) {
                    @SuppressLint("NotifyDataSetChanged")
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            rawOutLocationView.setText(null);
                            rawOutGoodsView.setText(null);
                            rawOutDetailAdapter.notifyDataSetChanged();
                            return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }
}