package com.example.haiwei_mom.wms.semi;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.SemiInVo;
import com.example.haiwei_mom.databinding.ActivitySemiInBinding;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import okhttp3.RequestBody;

public class SemiInActivity extends BaseActivity implements View.OnFocusChangeListener {
    private SemiInVo semi;
    private EditText semiInVehicle;
    private  EditText semiInLocation;
    private ActivitySemiInBinding binding;
    @SuppressLint("ClickableViewAccessibility")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_semi_in);
        semiInLocation = binding.semiInLocation;
        semiInLocation.setOnFocusChangeListener(this);
        semiInVehicle = binding.semiInVehicle;
        semiInVehicle.setOnFocusChangeListener(this);
        semiInVehicle.setOnEditorActionListener((v, actionId, event) -> {
            selectVehicleInfo();
            return true;
        });

        // semiInVehicle.setOnTouchListener((v, event) -> {
        //     final int DRAWABLE_RIGHT = 2;
        //     if (event.getAction() == MotionEvent.ACTION_UP) {
        //         // 获取触摸的位置
        //         int x = (int) event.getX();
        //         // 获取图标的边界
        //         int drawableRightWidth = binding.semiInVehicle.getCompoundDrawables()[DRAWABLE_RIGHT].getBounds().width();
        //         int drawableRightStart = (int) (binding.semiInVehicle.getWidth() - binding.semiInVehicle.getPaddingRight() - drawableRightWidth);
        //         // 判断是否点击了右侧图标
        //         if (x >= drawableRightStart && x <= (binding.semiInVehicle.getWidth() - binding.semiInVehicle.getPaddingRight())) {
        //             selectVehicleInfo();
        //             return true;
        //         }
        //     }
        //     return false;
        // });
        semi=new SemiInVo();
        binding.setData(semi);
    }

    private void selectVehicleInfo() {
        OkGo.<MyResult>post(url + "/wms/pda/semi/selectVehicleInfo")
                .params("code", semi.getCardNo()).execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            semi=gson.fromJson(body.getDataJson(),SemiInVo.class);
                            binding.setData(semi);
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }

    public void semiInSubmit(View view) {

        OkGo.<MyResult>post(url + "/wms/pda/semi/submitInstore")
                .upRequestBody(RequestBody.create(JSON, gson.toJson(semi)))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            Toast.makeText(SemiInActivity.this, "操作成功", Toast.LENGTH_SHORT).show();
                            finish();
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });

    }
    @Override
    public void getScannerData(String data) {
        super.getScannerData(data);
        if (focusedView!=null){

            if (focusedView==semiInVehicle){
                semi.setShelfNo(data);
                selectVehicleInfo();
            }else if (focusedView==semiInLocation){
                semiInLocation.setText(data);
            }
        }
    }

    private EditText focusedView;

    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        focusedView = (EditText) v;
    }
}