package com.example.haiwei_mom.wms.semi;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;

import androidx.databinding.DataBindingUtil;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.SemiOutVo;
import com.example.haiwei_mom.databinding.ActivitySemiOutBinding;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

import okhttp3.RequestBody;

public class SemiOutActivity extends BaseActivity {
    private SemiOutVo semi;
    private ActivitySemiOutBinding binding;
    private DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");

    @SuppressLint("ClickableViewAccessibility")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_semi_out);
        binding.semiOutCode.setOnEditorActionListener((v, actionId, event) -> {
            selectHppStorageInfo(binding.semiOutCode.getText().toString());
            return true;
        });
        // binding.semiOutCode.setOnTouchListener((v, event) -> {
        //     if (event.getAction() == MotionEvent.ACTION_UP) {
        //         // 获取触摸的位置
        //         int x = (int) event.getX();
        //         if (x >= 464) {
        //             selectHppStorageInfo(binding.semiOutCode.getText().toString());
        //             return true;
        //         }
        //     }
        //     return false;
        // });
    }

    private void selectHppStorageInfo(String code) {
        OkGo.<MyResult>post(url + "/wms/pda/semi/selectHppStorageInfo")
                .params("code", code)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            semi = gson.fromJson(body.getDataJson(), SemiOutVo.class);
                            semi.setOutNumber(semi.getStorageNum());
                            binding.setData(semi);
                            return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }

    public void semiInSubmit(View view) {
        if (semi == null) return;
        if (semi.getStorageNum() < semi.getOutNumber()) {
            myToastUitls.show("出库数量大于物料数量");
            return;
        }

        if (semi.getMinTime() != null && semi.getMaxTime() != null) {
            var now = LocalDateTime.now();
            LocalDateTime dateMin = LocalDateTime.parse(semi.getMinTime(), formatter);
            LocalDateTime dateMax = LocalDateTime.parse(semi.getMaxTime(), formatter);
            if (!now.isAfter(dateMin)) {
                myToastUitls.show("停放时间没有达到要求，不能使用");
                return;
            }

            if (!now.isBefore(dateMax)) {
                myToastUitls.show("已经失效，不能使用");
                return;
            }
        }

        OkGo.<MyResult>post(url + "/wms/pda/semi/submitOutInfo")
                .upRequestBody(RequestBody.create(JSON, gson.toJson(semi)))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {


                        }
                        myToastUitls.show(body.getMsg());
                    }
                });

    }

    @Override
    public void getScannerData(String data) {
        super.getScannerData(data);
        binding.semiOutCode.setText(data);
        selectHppStorageInfo(data);
    }
}